if (isObject(ECMAutoOverride))
	ECMAutoOverride.delete();

new ScriptObject(ECMAutoOverride) {

	//Class Assignment
	class = ECMAutoOverride;

	//Module Description
	Version = "1.0";
	DisplayName = "ECM 'Effect Filtering Server' Tracker and Mode Over-ride";


};



//Call Dialog...
function ECMAutoOverride::ShowDialog(%this) {

	Canvas.pushDialog(ECMAutoOverrideDlg);

}

function ECMAutoOverride::AddServer(%this, %switch) {

	//True = Nullvoice
	//false = Voicepack
	//echo("ADD SERVER: " @ $ECMVars::IP @ " - Is Nullvoice Filerer? (" @ %switch @ ")");
	
	if (%switch == 1) {
		%this.AddNullFilterer(ECMAutoOverrideAddIPText.getValue(), ECMAutoOverrideAddLabelText.getValue());
		ECMAutoOverrideNull.FillList();
	} else {
		%this.AddVPFilterer(ECMAutoOverrideAddIPText.getValue(), ECMAutoOverrideAddLabelText.getValue());
		ECMAutoOverrideVoicePack.FillList();
	}
	
	Canvas.popDialog(ECMAutoOverrideAddDlg);
	
	//Clear for next
	ECMAutoOverrideAddIPText.setText("");
	ECMAutoOverrideAddLabelText.setText("");
	
}



//Adds an IP to the Nullvoice black list
function ECMAutoOverride::AddNullFilterer(%this, %ip, %label) {

	if (%ip $= "") {
		MessageBoxOK("INPUT ERROR", "You must supply an IP to add to the Nullvoice Blockers List.");
		return;
	}

	%ip = "IP:" @ %ip;

	$pref::TracerECM::ServerFiltersNullIP = ($pref::TracerECM::ServerFiltersNullIP $= "") ? %ip : $pref::TracerECM::ServerFiltersNullIP TAB %ip;
	$pref::TracerECM::ServerFiltersNullLabel = ($pref::TracerECM::ServerFiltersNullLabel $= "") ? %label : $pref::TracerECM::ServerFiltersNullLabel TAB %label;
	
}

//Removes an IP from Nullvoice black list
function ECMAutoOverride::RemoveNullFilterer(%this, %ip) {

	%ips = $pref::TracerECM::ServerFiltersNullIP;
	%labels = $pref::TracerECM::ServerFiltersNullLabel;
	
	$pref::TracerECM::ServerFiltersNullIP = "";
	$pref::TracerECM::ServerFiltersNullLabel = "";
	
	%i = 0;
	
	while ((%cip = getField(%ips, %i)) !$= "") {
	
		%label = getField(%labels, %i);
	
		if (%cip !$= %ip) {
		
			$pref::TracerECM::ServerFiltersNullIP = ($pref::TracerECM::ServerFiltersNullIP $= "") ? %cip : $pref::TracerECM::ServerFiltersNullIP TAB %cip;
			$pref::TracerECM::ServerFiltersNullLabel = ($pref::TracerECM::ServerFiltersNullLabel $= "") ? %label : $pref::TracerECM::ServerFiltersNullLabel TAB %label;
		
		}
		
		%i++;
	
	}
	
	//if ($pref::TracerECM::ServerFiltersNullIP $= "\t") $pref::TracerECM::ServerFiltersNullIP = "";
	//if ($pref::TracerECM::ServerFiltersNullLabel $= "\t") $pref::TracerECM::ServerFiltersNullLabel = "";
	
}

//Checks IP if in Nullvoice black list
function ECMAutoOverride::CheckNullFiltered(%this, %ip) {

	if (strstr($pref::TracerECM::ServerFiltersNullIP, %ip) == -1)
		return false;
	else
		return true;

}



//Adds an IP to the VoicePack black list
function ECMAutoOverride::AddVPFilterer(%this, %ip, %label) {

	if (%ip $= "") {
		MessageBoxOK("INPUT ERROR", "You must supply an IP to add to the Voicepack Blockers List.");
		return;
	}
	
	%ip = "IP:" @ %ip;

	$pref::TracerECM::ServerFiltersVPIP = ($pref::TracerECM::ServerFiltersVPIP $= "") ? %ip : $pref::TracerECM::ServerFiltersVPIP TAB %ip;
	$pref::TracerECM::ServerFiltersVPLabel = ($pref::TracerECM::ServerFiltersVPLabel $= "") ? %label : $pref::TracerECM::ServerFiltersVPLabel TAB %label;

}

//Removes an IP from Voicepack black list
function ECMAutoOverride::RemoveVPFilterer(%this, %ip) {

	%ips = $pref::TracerECM::ServerFiltersVPIP;
	%labels = $pref::TracerECM::ServerFiltersVPLabel;
	
	$pref::TracerECM::ServerFiltersVPIP = "";
	$pref::TracerECM::ServerFiltersVPLabel = "";
	
	%i = 0;
	
	while ((%cip = getField(%ips, %i)) !$= "") {
	
		%label = getField(%labels, %i);
	
		if (%cip !$= %ip) {
		
			$pref::TracerECM::ServerFiltersVPIP = ($pref::TracerECM::ServerFiltersVPIP $= "") ? %cip : $pref::TracerECM::ServerFiltersVPIP TAB %cip;
			$pref::TracerECM::ServerFiltersVPLabel = ($pref::TracerECM::ServerFiltersVPLabel $= "") ? %label : $pref::TracerECM::ServerFiltersVPLabel TAB %label;
		
		}
		
		%i++;
	
	}
	
	//If the last item was deleted, return list to blank
	//if ($pref::TracerECM::ServerFiltersVPIP $= "\t") $pref::TracerECM::ServerFiltersVPIP = "";
	//if ($pref::TracerECM::ServerFiltersVPLabel $= "\t") $pref::TracerECM::ServerFiltersVPLabel = "";
	
}

//Checks IP if in Voiepack black list
function ECMAutoOverride::CheckVPFiltered(%this, %ip) {

	if (strstr($pref::TracerECM::ServerFiltersVPIP, %ip) == -1)
		return false;
	else
		return true;

}





    //////////////////
///// GUI Function ///////////////////////////////////////////////////////////////////////////////////////////////////////////
  //////////////////

//Dialog Initialize
function ECMAutoOverrideDlg::onWake(%this) {

	ECMAutoOverrideNull.FillList();
	ECMAutoOverrideVoicePack.FillList();

}

//Servers that block Nullvoice Effect GUI Events
function ECMAutoOverrideNull::FillList(%this) {

	%this.clear();
	
	%i = 0;
	
	while ((%ip = getField($pref::TracerECM::ServerFiltersNullIP, %i)) !$= "") {
		
		%label = getField($pref::TracerECM::ServerFiltersNullLabel, %i);
		
		%this.addRow(%i, %label TAB %ip);
		
		%i++;
		
	}

}

function ECMAutoOverrideNull::RemoveSelected(%this) {

	ECMAutoOverride.RemoveNullFilterer(getField($pref::TracerECM::ServerFiltersNullIP, %this.getSelectedId()));
	
	%this.FillList();

}

//Servers that block Voicepacks GUI Events
function ECMAutoOverrideVoicePack::FillList(%this) {

	%this.clear();
	
	%i = 0;
	
	while ((%ip = getField($pref::TracerECM::ServerFiltersVPIP, %i)) !$= "") {
		
		%label = getField($pref::TracerECM::ServerFiltersVPLabel, %i);
		
		%this.addRow(%i, %label TAB %ip);
		
		%i++;
		
	}

}

function ECMAutoOverrideVoicePack::RemoveSelected(%this) {

	ECMAutoOverride.RemoveVPFilterer(getField($pref::TracerECM::ServerFiltersVPIP, %this.getSelectedId()));
	
	%this.FillList();

}

    ////////////////////////
///// Voicebind Checking ///////////
  ////////////////////////
  
//This part intercepts chat messages and makes sure that the information you sent is being relayed thru the server (and not blocked)
//if the server does block any info, the appropriate action is taken to make sure the script doesn't try to do things it shouldn't, next time

//The Classic nullfilter uses a special message to tell us we're nullvoice using llamas
addMessageCallback('MsgClientJoin', handleClientJoin);
package ECMChatMessageChecks {

	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {
	
		//Allow other processes to handle this
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
		
		//All we're doing here is making sure everything is hunky-dory with how chat messages are being sent.
		
		//TracerECM.myTag is maintained by FunctionModules/IssueTask.src.cs
		
		//Only check messages from me
		//echo("Voice Chat by: " @ %sender);
		if (%sender == TracerECM.myClient) {
		
			//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
			//then the voice bind will be considered "blocked" and ECM will react accordingly.
			cancel(TracerECM.LastVoiceEvent);
			
		
			//Make sure, if we're using nullvoice, that our voice is infact being sent as "null" (HV Nullfilter)
			if (($pref::TracerECM::OperationalMode == 1) && (detag(%voice) !$= "")) {
			
				//We're being blocked!!!
				ECMAutoOverride_VoiceBlocked();
			
			}
			
			//Clear this flag, so that no more tests are performed on issued commands, we only wanted to do this once. This way, if the admin mutes my
			//loud ass later on, it won't drive the script crazy.
			TracerECM.NotTested = false;
			
		}
		
		
	
	}
};
activatePackage(ECMChatMessageChecks);

//This function is called by the detection process when a voice bind block has occurred.
function ECMAutoOverride_VoiceBlocked() {

	//echo("Block Detected!");

	//%cmd = "ECMAutoOverride_AddThisServerToNull();"
	
	//ECMAutoOverride.AddNullFilterer(TracerECM.CurrentAddress, TracerECM.CurrentServer);
	
	//Make sure this server isn't already added to null-list
	if (!ECMAutoOverride.CheckNullFiltered(TracerECM.CurrentAddress)) {
	
		//Not in null list currently, ask user to get it added...
		%cmd = "ECMAutoOverride.AddNullFilterer(TracerECM.CurrentAddress, TracerECM.CurrentServer);";
		
	}
	
	//If we're not in Nullvoice Mode and we still got blocked, check to see if this server is in the Voicepack blockers list
	if (($pref::TracerECM::OperationalMode != 1) && (!ECMAutoOverride.CheckVPFiltered(TracerECM.CurrentAddress))) {
	
		//Not in VoicePack List currently, ask user to get it added...
		%cmd = "ECMAutoOverride.AddVPFilterer(TracerECM.CurrentAddress, TracerECM.CurrentServer);";
		
	}
	
	//Only show popup is there's a %cmd to be executed
	if (%cmd !$= "") {

		MessageBoxYesNo("CHAT BLOCKED!", "TracerECM has detected that 1 or more of your chat binds did not go through. If you believe this has occured because this server has filters, please click the 'Yes' button.", %cmd, "");

	}
}
