if (isObject(ECMBinds))
	ECMBinds.delete();

new ScriptObject(ECMBinds) {

	Version = "4.0";
	DisplayName = "ECM Binds";

};


deactivatePackage(ECMBindMaps);
package ECMBindMaps {

//Function Over-ride Functions_________________________________________________________________________
//-------------------------------------------------------------------------------------------------------

	function updateActionMaps()
	{
		parent::updateActionMaps();
		
		//Rebind Keys when Hud Modes change (Enter a vehicle and stuff)...
		switch$ ($HudMode)
		{
			case "Pilot": //Piloting Vehicle
				//TDX Enhanced Menu
				passengerKeys.copyBind( moveMap, activateECMMenuHud );
				//Tracer Dance...
				passengerKeys.copyBind( moveMap, RandomDanceToggle);
				//Tracer Awwww...
				passengerKeys.copyBind( moveMap, AwwwSpamToggle);
				//Tracer Moo
				passengerKeys.copyBind( moveMap, MooToggle);
				//Shut up!
				passengerKeys.copyBind( moveMap, TracerSHUTUP);
				//Tracer Death Cry
				passengerKeys.copyBind( moveMap, TracerDeath);
				//Tracer Umph
				passengerKeys.copyBind( moveMap, TracerUmph);
				//Tracer Umph2
				passengerKeys.copyBind( moveMap, TracerUmph2);
				//Voice Cycler
				passengerKeys.copyBind( moveMap, ECMCycleVoice);
				//Voice Cycler Back
				passengerKeys.copyBind( moveMap, ECMCycleVoiceBack);
				//In-Game menu
				passengerKeys.copyBind( moveMap, ECMEditNow);
				
				
		}
		
	}

	function DebriefGui::onWake( %this ) {

		parent::onWake( %this );

		//Copy our binds to debrief bind map
		//TDX Enhanced Menu
		debriefMap.copyBind( moveMap, activateECMMenuHud );
		//Tracer Dance...
		debriefMap.copyBind( moveMap, RandomDanceToggle);
		//Tracer Awwww...
		debriefMap.copyBind( moveMap, AwwwSpamToggle);
		//Tracer Moo
		debriefMap.copyBind( moveMap, MooToggle);
		//Shut up!
		debriefMap.copyBind( moveMap, TracerSHUTUP);
		//Tracer Death Cry
		debriefMap.copyBind( moveMap, TracerDeath);
		//Tracer Umph
		debriefMap.copyBind( moveMap, TracerUmph);
		//Tracer Umph2
		debriefMap.copyBind( moveMap, TracerUmph2);
		//Voice Cycler
		debriefMap.copyBind( moveMap, ECMCycleVoice);
		//Voice Cycler going back
		debriefMap.copyBind( moveMap, ECMCycleVoiceBack);

	}


//End Function Over-ride Functions_______________________________________________________________________
//-----------------------------------------------------------------------------------------------------

//Define Control Key Binds_____________________________________________________________________________
//-------------------------------------------------------------------------------------------------------

	function OptionsDlg::onWake(%this)
	{
		
		if (!ECMBinds.BindsSet) {

			//Key Mapping Add Tracer Dance
			$RemapName[$RemapCount] = "ECM Dance ON/OFF";
			$RemapCmd[$RemapCount]  = "RandomDanceToggle";
			$RemapCount++;
		
			//Key Mapping Add Tracer Awww...
			$RemapName[$RemapCount] = "ECM Aww ON/OFF";
			$RemapCmd[$RemapCount]  = "AwwwSpamToggle";
			$RemapCount++;

			//Key Mapping Add Tracer Mooooooo...
			$RemapName[$RemapCount] = "ECM Moo! ON/OFF";
			$RemapCmd[$RemapCount]  = "MooToggle";
			$RemapCount++;

			//Key Mapping Add Tracer SHUTUP!
			$RemapName[$RemapCount] = "ECM SHUTUP!";
			$RemapCmd[$RemapCount]  = "TracerSHUTUP";
			$RemapCount++;

			//Key Mapping Add Tracer Death!
			$RemapName[$RemapCount] = "ECM DeathCry";
			$RemapCmd[$RemapCount]  = "TracerDeath";
			$RemapCount++;

			//Key Mapping Add Tracer Umph!
			$RemapName[$RemapCount] = "ECM Umph";
			$RemapCmd[$RemapCount]  = "TracerUmph";
			$RemapCount++;

			//Key Mapping Add Tracer Umph!
			$RemapName[$RemapCount] = "ECM Uhhnn";
			$RemapCmd[$RemapCount]  = "TracerUmph2";
			$RemapCount++;

			//Key Mapping Add Tracer Chat Menu
			$RemapName[$RemapCount] = "Enhanced Chat Menu";
			$RemapCmd[$RemapCount]  = "activateECMMenuHud";
			$RemapCount++;

			//Key mapping to ingame edit
			$RemapName[$RemapCount] = "ECM In Game Edit";
			$RemapCmd[$RemapCount]  = "ECMEditNow";
			$RemapCount++;

			//Key mapping to ingame edit
			$RemapName[$RemapCount] = "ECM Cycle Voice";
			$RemapCmd[$RemapCount]  = "ECMCycleVoice";
			$RemapCount++;

			//Key mapping to ingame edit
			$RemapName[$RemapCount] = "ECM Back V. Cycle";
			$RemapCmd[$RemapCount]  = "ECMCycleVoiceBack";
			$RemapCount++;

			//Run Once
			ECMBinds.BindsSet = true;
		
		}

		//Pass on handling...
		parent::onWake(%this);

	}
};
activatePackage(ECMBindMaps);

//End Define Control Key Binds___________________________________________________________________________
//-----------------------------------------------------------------------------------------------------



//Add Item to SimGroup_________________________________________________________________________________
//-------------------------------------------------------------------------------------------------------
TracerECM.Modules.add(ECMBinds);