//The one and Only Property for this module:

//Property Types:
//SELECT: A Selection Pulldown
//VALUE:  User Entered Value
//TOGGLE: On/Off Switch
//Create this ECM Functions Object
new ScriptObject(ECMFIssueTask) {

	class = "ECMFIssueTask";

	DisplayName = "Issue Task";
	ReferenceName = "issuetask";
	Version = "1.0";
	Description = "Will issue a task to your team. LOS = Task issued on object in Line of sight (even the ground), SELF = Task issued on self";

};

ECMFIssueTask.Properties[0] = new ScriptObject() {

	Name = "Task:";
	Type = "SELECT";

	Label[0] = "Take Flag SELF";
	Task[0] = 'TakeFlag';
	LOS[0] = 0;

	Label[1] = "Repair Object LOS";
	Task[1] = 'RepairObject';
	LOS[1] = 1;

	Label[2] = "Target LOS";
	Task[2] = 'LazeObject';
	LOS[2] = 1;

	Label[3] = "Target SELF";
	Task[3] = 'LazeObject';
	LOS[3] = 0;

	Label[4] = "Escort SELF";
	Task[4] = 'EscortPlayer';
	LOS[4] = 0;

	Label[5] = "Escort LOS";
	Task[5] = 'EscortPlayer';
	LOS[5] = 1;

	Label[6] = "Repair Player SELF";
	Task[6] = 'RepairPlayer';
	LOS[6] = 0;

	Label[7] = "Repair Player LOS";
	Task[7] = 'RepairPlayer';
	LOS[7] = 1;

	Label[8] = "Give Flag SELF";
	Task[8] = 'GiveFlag';
	LOS[8] = 0;

	Label[9] = "Give Flag LOS";
	Task[9] = 'GiveFlag';
	LOS[9] = 1;

	Label[10] = "Need Ride SELF";
	Task[10] = 'NeedRide';
	LOS[10] = 0;

	Label[11] = "Need Passenger SELF";
	Task[11] = 'NeedPassenger';
	LOS[11] = 0;

	Label[12] = "Need Passenger LOS";
	Task[12] = 'NeedPassenger';
	LOS[12] = 1;

	Count = 13;

};

ECMFIssueTask.PropertyCount = 1;


function ECMFIssueTask::execute(%this, %parameters) {

	%taskNum = getField(%parameters, 0);

	if (ECMFIssueTask.Properties[0].LOS[%taskNum]) {
		ServerConnection.sendLOSTarget();
	} else {
		%mytarget = createClientTarget(PlayerList.getTargetIDByID(PlayerList.getMyID()), "0 0 0");
		%mytarget.sendToServer();
	}

	

    commandToServer('BuildClientTask', ECMFIssueTask.Properties[0].Task[%taskNum], true);
	commandToServer('SendTaskToTeam',true);

}


ECMFunctions.functionModules.add(ECMFIssueTask);