if (isObject(ECM_IO))
	ECM_IO.delete();

new ScriptObject(ECM_IO) {

	Version = "5.0";
	DisplayName = "ECM Input/Output";


};



//Ingoing/Outgoing Messages Handler____________________________________________________________________
//-------------------------------------------------------------------------------------------------------

function issueECMCmd( %menu, %index) {


	//---[Voice Pack Handler]--------------------------
	if (getSubStr(%temp,0,1) $= "`") {

		%cmdNum = getSubStr(%temp,1,strlen(%menu.command[%index]));

		//Grab Command from list
		%command = TracerECM.VoicePackList[%cmdNum];

		//Extract the information from the item
		//TO DO: This process is ripped off, and it sucks, improve it
		%cmdCode = getWord( %command, 0 );
		%cmdId = getSubStr( %cmdCode, 1, strlen( %command ) - 1 );
		%cmdString = getWord( %command, 1 );
		%chatItem = $ChatTable[%cmdId];

		//Remove Text if selected
		if (TracerECM.NoVoicePackText)
			%message = "~w" @ %chatItem.audioFile;
		else
			%message = %VPColor @ %chatItem.text @ "~w" @ %chatItem.audioFile; 

		//Determine sending method
		if ( %chatItem.teamOnly ) {
			commandToServer('teamMessageSent', %message);
		} else {
			commandToServer('messageSent', %message);
		}
		
		//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
		//then the voice bind will be considered "blocked" and ECM will react accordingly.
		if (TracerECM.NotTested)
			TracerECM.LastVoiceEvent = schedule($pref::TracerECM::BindTimeout, 0, "ECMAutoOverride_VoiceBlocked");



	//---[End Voice Pack Handler]---------------------
	} else {
	//---[Enhanced Chat Menu]-------------------------

		%commandObj = %menu.command[%index];      //ECM Command Object (5.0+)
		//%isVP = %menu.isVoicePack[%index];        //VoicePack Flag

		if ($pref::TracerECM::SubduedText)
			%VPColor = TracerECM.VoicePackColor;


		if (%commandObj.startVoicePack !$= "") {
			//Voicepack Root item
			for (%i = 0; %i < ECMVoicePackDriver.VoicePackCount; %i++) {
				if (ECMVoicePackDriver.VoicePacks[%i].ID $= %commandObj.startVoicePack) {
					ECMShowHUD.setMenu(ECMVoicePackDriver.VoicePacks[%i].Name, ECMVoicePackDriver.VoicePacks[%i].rootMenu);
					return;
				}
			}
				
		} else if (%commandObj.isVoicePackItem) {
			//Voicepack Item
			%string = %VPColor @ %commandObj.VPchatText @ "~wK" @ %commandObj.VPchatSound;
		} else if ($pref::TracerECM::OperationalMode == 1) {
			//NullVoice
			%text = %commandObj.nullChatText[TracerECM.PlayerVoiceNum];
			%sound = %commandObj.nullChatSound[TracerECM.PlayerVoiceNum];
			%string = %text @ "~w" @ %sound @ ".wav";
			if (%string $= "~w.wav")
				%string = "";
		} else {
			//Normal Enhanced Chat
			%text = %commandObj.chatText[TracerECM.PlayerVoiceNum];
			%sound = %commandObj.chatSound[TracerECM.PlayerVoiceNum];
			%string = %text @ "~w" @ %sound;
			if (%string $= "~w")
				%string = "";
		}
	
		//Console Echo
		//echo("OUTGOING STRING: " @ %string);
	
		if (%string !$= "") {
			//Not empty in this instance, send it
			if (%commandObj.isTeam)
				commandToServer('teamMessageSent', %string);
			else
				commandToServer('messageSent', %string);
			//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
			//then the voice bind will be considered "blocked" and ECM will react accordingly.
			if (TracerECM.NotTested)
				TracerECM.LastVoiceEvent = schedule($pref::TracerECM::BindTimeout, 0, "ECMAutoOverride_VoiceBlocked");

		} else {
			//Canned Chat Item
			//Only do Canned Chat item if no ECM Entry exists on this commandObj/voice/mode
			%b = %commandObj.cannedChat;
			for(%d=0; ECMSoundExplorer.CannedList[%d]!$=""; %d++)
			{
				if(ECMSoundExplorer.CannedList[%d]$=%b)
				{
					%cmdID = ECMSoundExplorer.CannedItems[%d];
				}

			}

			commandToServer( 'CannedChat', %cmdID, false);

		}

		//Console Command
		if (%commandObj.consoleCommand !$= "")
			eval(%commandObj.consoleCommand);

		//ECM Function execution...
		if (%commandObj.ECMFunction !$= "")
			execECMFunction(%commandObj.ECMFunction, %commandObj.ECMFunctionParameters);


	}
	//---[End Enhanced Chat Menu]---------------------


	ECMShowHUD.cancelMenu();

}



function DEPRICATEDissueECMCmd( %menu, %index ) 
	{

		%temp = %menu.command[%index];
		%isVoicePack = %menu.isVoicePack[%index];
		
			//Apply VoicePack Color if enabled
			if ($pref::TracerECM::SubduedText)
				%VPColor = TracerECM.VoicePackColor;

			if(getSubStr(%temp,0,1) $= "`") {
			
				//Handles Voice Pack Items added to my menu
				%cmdNum = getSubStr(%temp,1,strlen(%temp));

				//Grab Command from list
				%command = TracerECM.VoicePackList[%cmdNum];

				//Extract the information from the item
				//TO DO: This process is ripped off, and it sucks, improve it
				%cmdCode = getWord( %command, 0 );
				%cmdId = getSubStr( %cmdCode, 1, strlen( %command ) - 1 );
				%cmdString = getWord( %command, 1 );
				%chatItem = $ChatTable[%cmdId];

				//Remove Text if selected
				if (TracerECM.NoVoicePackText)
					%message = "~w" @ %chatItem.audioFile;
				else
					%message = %VPColor @ %chatItem.text @ "~w" @ %chatItem.audioFile; 

				//Determine sending method
				if ( %chatItem.teamOnly ) {
					commandToServer('teamMessageSent', %message);
				} else {
					commandToServer('messageSent', %message);
				}
				
				//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
				//then the voice bind will be considered "blocked" and ECM will react accordingly.
				if (TracerECM.NotTested)
					TracerECM.LastVoiceEvent = schedule($pref::TracerECM::BindTimeout, 0, "ECMAutoOverride_VoiceBlocked");

			} else {

				//Determine if this is a Canned Chat Item or an Enhanced Chat item.
				if(getSubStr(%temp,0,1) $= "~") {

					//Is Canned Chat
					%b = getSubStr(%temp, 1, (strlen(%temp) - 1));

					for(%d=1; ECMSoundExplorer.CannedList[%d]!$=""; %d++)
					{
						%test = ECMSoundExplorer.CannedList[%d];
						if(ECMSoundExplorer.CannedList[%d]$=%b)
						{
							%cmdID = ECMSoundExplorer.CannedItems[%d];
						}

					}
		
					commandToServer( 'CannedChat', %cmdID, false);

				} else {
			
					//Is Enchanced Chat
					//Search for `voice` - (Insert voice dir, to over-ride NULL voice)
					%pos = strpos( %temp, "`voice`");
					if (%pos != -1)
						%temp = ( getSubStr( %temp, 0, %pos ) @ "voice/" @ TracerECM.PlayerVoice @ getSubStr(%temp, (%pos + 7), strlen(%temp)) );

					//Now determine if it is a team message or not, or apply over-ride.
					if ((strpos(%temp, " `(TEAM)") == -1) && (!$pref::TracerECM::TeamOnly)) {

						//Append a .wav if this is a Nullvoice message
						if (($pref::TracerECM::VoiceMode == 1) && (strpos(%temp, "~w") != -1))
							%temp = %temp @ ".wav";

						//Strip text from message and leave only sound if wanted
						if ($pref::TracerECM::NoVoicePackText && %isVoicePack)
							%temp = getSubStr(%temp, strpos(%temp, "~w"), (strlen(%temp) - strpos(%temp, "~w")));
						
						if (%isVoicePack)
							commandToServer( 'messageSent', %VPColor @ %temp);
						else
							commandToServer( 'messageSent', %temp);

						//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
						//then the voice bind will be considered "blocked" and ECM will react accordingly.
						//TracerECM.LastVoiceEvent = schedule($pref::TracerECM::BindTimeout, 0, "ECMAutoOverride_VoiceBlocked");


					} else {

						//Only try to strip `(TEAM) tag if its there
						if (strpos(%temp, " `(TEAM)") != -1)
							%temp = getSubStr( %temp, 0, strpos(%temp, " `(TEAM)") );

						//Append a .wav if this is a Nullvoice message
						if (($pref::TracerECM::VoiceMode == 1) && (strpos(%temp, "~w") != -1))
							%temp = %temp @ ".wav";

						//Strip text from message and leave only sound if wanted
						if ($pref::TracerECM::NoVoicePackText && %isVoicePack)
							%temp = getSubStr(%temp, strpos(%temp, "~w"), (strlen(%temp) - strpos(%temp, "~w")));

						if (%isVoicePack)
							commandToServer( 'teammessageSent', %VPColor @ %temp);
						else
							commandToServer( 'teammessageSent', %temp);
							
						//This scheduled event is created everytime a voice bind is said. If it is not canceled in a defined amount of time, $pref::TracerECM::BindTimeout,
						//then the voice bind will be considered "blocked" and ECM will react accordingly.
						//TracerECM.LastVoiceEvent = schedule($pref::TracerECM::BindTimeout, 0, "ECMAutoOverride_VoiceBlocked");

					}

					
				
				}

			}

		ECMShowHUD.cancelMenu();

	}

	//Back Compatability: VoicePackDX Uses this to issue a command through my script
	//Old TracerDXChat crap
	function issueTDXCCmd( %menu, %index ) {

		issueECMCmd( %menu, %index );

	}

deactivatePackage(TracerECMNullVoicePackage);
package TracerECMNullVoicePackage {

	// Now this little beauty of an over-ride is what enables us to have a NULL voice, so we can "say" any sound we want :)
	function connect( %address, $JoinGamePassword, %playerName, %playerRaceGender, %playerSkin, %playerVoice, %playerVoicePitch ) {

		//Clear myClient data item to make sure it is grabbed
		TracerECM.myClient = 0;

		//Store this server's address for later
		TracerECM.CurrentAddress = %address;

		//Set flag so the Voice block "auto-detect" feature will run tests on your first voice bind. This flag is cleared once
		//a test to make sure your first bind went thru worked.
		TracerECM.NotTested = true;
		
		//Auto Over-ride check
		if ($pref::TracerECM::AutoOverride) {
		
			//MessageBoxOK("TEST" , %address);
			
			//echo(%address);
		
			if (ECMAutoOverride.CheckVPFiltered(%address)) {
			
				$pref::TracerECM::OperationalMode = 2; //Normal
				
			} else if (ECMAutoOverride.CheckNullFiltered(%address) && ($pref::TracerECM::VoiceMode == 1)) {
			
				$pref::TracerECM::OperationalMode = 0; //Enhanced
				
			} else
			
				$pref::TracerECM::OperationalMode = $pref::TracerECM::VoiceMode;
		
		} else
			$pref::TracerECM::OperationalMode = $pref::TracerECM::VoiceMode;

		if ($pref::TracerECM::OperationalMode == 1)
			%playerVoice = "";

		parent::connect( %address, $JoinGamePassword, %playerName, %playerRaceGender, %playerSkin, %playerVoice, %playerVoicePitch );

	}

	function localConnect( %playerName, %playerRaceGender, %playerSkin, %playerVoice, %playerVoicePitch ) {

		$pref::TracerECM::OperationalMode = $pref::TracerECM::VoiceMode;

		if ($pref::TracerECM::OperationalMode == 1)
			%playerVoice = "";

		parent::localConnect( %playerName, %playerRaceGender, %playerSkin, %playerVoice, %playerVoicePitch );

	}

};
activatePackage(TracerECMNullVoicePackage);

//End Ingoing/Outgoing Messages Handler__________________________________________________________________
//-----------------------------------------------------------------------------------------------------


//Add Item to SimGroup_________________________________________________________________________________
//-------------------------------------------------------------------------------------------------------
TracerECM.Modules.add(ECM_IO);