if (isObject(ECMenuBuild))
	ECMenuBuild.delete();


new ScriptObject(ECMenuBuild) {

	class = ECMenuBuild;

	Version = "5.0";
	DisplayName = "ECM Menu Builder";

};

ECMenuBuild.MenuList = new SimSet();
ECMenuBuild.CommandObjects = new SimSet();

//Chat Menu Builder Functions__________________________________________________________________________
//-------------------------------------------------------------------------------------------------------

function ECMenuBuild::activateMenu(%this, %filename) {
	
	
	if (!isFile(%filename))
		%filename = "scripts/TDX/ECM/Menus/Current.mnu.cs";
		
		
	//Delete existing .dso, if any
	if (isFile(%filename @ ".dso"))
		deleteFile(%filename @ ".dso");

	ECMenuBuild.MenuList.clear();
	ECMenuBuild.CommandObjects.clear();

	ECMenuBuild.RootMenu = new ActionMap();
	ECMenuBuild.MenuList.add( ECMenuBuild.RootMenu );
	ECMenuBuild.CurrentMenu = ECMenuBuild.RootMenu;
	ECMenuBuild.CurrentMenu.optionCount = 0;
	ECMenuBuild.CurrentMenu.bindCmd(keyboard, escape, "ECMShowHUD.cancelMenu();", "");


	exec( %filename );

	//CloseMessagePopup();

	//Now Load in VoicePackDX
	//if (isobject(VoicePackDX))

		//Rebuild The VoicePackDX Menu Items
	//	ECMVoicePackDXSupport.RebuildMenus();

	//else {

		//Load in voice pack...
	//	%scriptname = "scripts/" @ $voicePackTable[$pref::Audio::defaultVoicePack] @ "VoicePack.cs";

		//Clean up menu from previous voice pack calls.
		//TO DO:

		//Turn on flag to allow my over-rides to grab binds
	//	TracerECM.GrabVoicePackBinds = true;

		//Execute VoicePack File
	//	exec(%scriptname);

		//Turn flag back off
	//	TracerECM.GrabVoicePackBinds = false;

	//}

	//Clean Up Mess we made of the Original T2 Voice Bind Menu ;)
	//TO DO: Can't EXEC VoicePackActivate(); ... It'll fuck my shit up. [FIXED]

}

function ECMenuBuild::startMenu(%this, %heading) {

	%key = getSubStr( %heading, 0, strpos(%heading, ":") );
	%text = getSubStr(%heading, (strpos(%heading, ":")+2), (strlen(%heading) - (strpos(%heading, ":")+2)));
	%menu = new ActionMap();
	ECMenuBuild.MenuList.add( %menu );
	%cm = ECMenuBuild.CurrentMenu;
	%cm.bindCmd(keyboard, %key, "ECMShowHUD.setMenu(\"" @ %text @ "\", " @ %menu @ ");", "");
	%cm.option[%cm.optionCount] = %key @ ": " @ %text;
	%cm.command[%cm.optionCount] = %menu;
	%cm.isMenu[%cm.optionCount] = 1;
	%cm.optionCount++;
	%menu.parent = %cm;
	%menu.bindCmd(keyboard, escape, "ECMShowHUD.cancelMenu();", "");
	%menu.optionCount = 0;
	ECMenuBuild.CurrentMenu = %menu;
}


function ECMenuBuild::endMenu() {

	ECMenuBuild.CurrentMenu = ECMenuBuild.CurrentMenu.parent;
}


function ECMenuBuild::addCmdBind(%this, %keyDesc, %isTeam) {

	%key = getSubStr( %keyDesc, 0, strpos(%keyDesc, ":") );
	%text = getSubStr(%keyDesc, (strpos(%keyDesc, ":")+2), (strlen(%keyDesc) - (strpos(%keyDesc, ":")+2)));
	$ECMenuBuild::cm = ECMenuBuild.CurrentMenu;
	$ECMenuBuild::cm.bindCmd(keyboard, %key, "issueECMCmd(" @ $ECMenuBuild::cm @ "," @ $ECMenuBuild::cm.optionCount @ ");", "");
	$ECMenuBuild::cm.option[$ECMenuBuild::cm.optionCount] = %key @ ": " @ %text;
	$ECMenuBuild::cm.isMenu[$ECMenuBuild::cm.optionCount] = 0;

	$ECMenuBuild::commandObj = new scriptObject();

	if (%isTeam)
		$ECMenuBuild::commandObj.isTeam = true;
	else
		$ECMenuBuild::commandObj.isTeam = false;

	ECMenuBuild.CommandObjects.add($ECMenuBuild::commandObj);

}

function ECMenuBuild::addCmdDesc(%this, %type, %indexValue, %text, %sound) {

	switch$ (%type) {

		case 0: //Voice Bind Description
			$ECMenuBuild::commandObj.chatText[%indexValue] = %text;
			$ECMenuBuild::commandObj.chatSound[%indexValue] = %sound;

		case 1: //Null Voice Bind Description
			$ECMenuBuild::commandObj.nullChatText[%indexValue] = %text;
			$ECMenuBuild::commandObj.nullChatSound[%indexValue] = %sound;

		case 2: //ECM Function Description
			$ECMenuBuild::commandObj.ECMFunction = %text;
			$ECMenuBuild::commandObj.ECMFunctionParameters = %sound;
			//if ($ECMenuBuild::commandObj.ECMFunctionCount <= %indexValue)
			//	$ECMenuBuild::commandObj.ECMFunctionCount = (%indexValue + 1);

		case 3: //Console Command
			$ECMenuBuild::commandObj.consoleCommand = %text;

		case 4: //Canned Chat Item
			$ECMenuBuild::commandObj.cannedChat = %text;
			
		case 5: //Voicepack Entrypoint
			$ECMenuBuild::commandObj.startVoicePack = %text;

	}
}

//Type Values
//0 Voice Bind
//1 Null Voice Bind
//2 ECM Function
//3 Console Command

//(0) Voice Type Values
//00 Bot
//01 Warrior
//02 Monster
//03 Predator
//04 Hero
//05 Iceman
//06 Rouge
//07 Hardcase
//08 Psyco
//09 Heroine
//10 Profesional
//11 Cadet
//12 Veteran
//13 Amazon


//(1) ECM Function Values

function ECMenuBuild::endCmdBind(%this) {

	$ECMenuBuild::cm.command[$ECMenuBuild::cm.optionCount] = $ECMenuBuild::commandObj;
	$ECMenuBuild::cm.optionCount++;

}

//End Chat Menu Builder Functions________________________________________________________________________
//-----------------------------------------------------------------------------------------------------



function ECMenuBuild::SaveDataMenu( %this, %filename ) {

	//No FileName? Ok, someone else is calling this function wrong.
	if ( %filename $= "" )
		%filename = ("scripts/TDX/ECM/Menus/Current.mnu.cs");

	//Create a new file object so we can write this shit
	new fileObject( "saveFile" );
	saveFile.openForWrite( %filename );

	//Print out a little header so people know what the hell this file is
	saveFile.writeLine( "//----------------------------------------------------------------------------\\\\" );
	saveFile.writeLine( "//                                                                            \\\\" );
	saveFile.writeLine( "//             TracerDX's Enhanced Chat - Menu Definition File                \\\\" );
	saveFile.writeLine( "//                                                                            \\\\" );
	saveFile.writeLine( "//             Written by TracerDX (tracer@planettracerdx.com)                \\\\" );
	saveFile.writeLine( "//                    http://www.planettracerdx.com                           \\\\" );
	saveFile.writeLine( "//                                                                            \\\\" );
	saveFile.writeLine( "//----------------------------------------------------------------------------\\\\" );
	saveFile.writeLine( " " );
	saveFile.writeLine( " " );

	//Grab the root, start from
	%rootItem = ECMenuBuild.RootMenu;

	//Begin writing
	ECMenuBuild.writeDataNode( saveFile, %rootItem, "" );

	//Close File, delete file object (not the file)
	saveFile.close();
	saveFile.delete();


}

//Self calling function that traverses the GUI Tree and saves all items to a file
function ECMenuBuild::writeDataNode( %this, %file, %item, %space ) {

	
	for (%a = 0; %a < %item.optionCount; %a++) {

		%temp = %item.option[%a];

		//Parse a few items out of the text
		%key = getSubStr( %temp, 0, strpos(%temp, ":") );
		%text = getSubStr(%temp, (strpos(%temp, ":")+2), (strlen(%temp) - (strpos(%temp, ":")+2)));
		%command = %item.command[%a];

		//Find out if this is a menu item or bind (command) item 
		if ( %item.isMenu[%a] == 1 ) {

			//Write corresponding commands to file in order to rebuild this submenu: Start of a new menu
			%file.writeLine( %space @ "ECMenuBuild.startMenu( \"" @ %key @ ": " @ %text @ "\" );" );

			//Grab the first child item of this submenu
			%child = %item.command[%a];
			
			if (isObject(%child))
				ECMenuBuild.writeDataNode( %file, %child, ("\t" @ %space) );
	
			//Finish this submenu up.
			%file.writeLine( %space @ "ECMenuBuild.endMenu(); // " @ %text );
			%file.writeLine( " ");

		} else {

			//Parse out Data for this bind (command) item
			%commandObj = %command;

			//Write the command to recreate this bind (command) item
			if (%commandObj.isTeam)
				%file.writeLine( %space @ "ECMenuBuild.addCmdBind( \"" @ %key @ ": " @ %text @ "\", true);" );
			else
				%file.writeLine( %space @ "ECMenuBuild.addCmdBind( \"" @ %key @ ": " @ %text @ "\");" );
			//Begin Writing Command Descrpition Entries
			// 0 - Voice Bind Descriptions
			for (%i = 0; %i < 14; %i++) {
				%text = %commandObj.chatText[%i];
				%sound = %commandObj.chatSound[%i];
				if ((%text !$= "") && (%sound !$= ""))
					%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(0, " @ %i @ ", \"" @ ECMfixQuotesForSave(%text) @ "\", \"" @ %sound @ "\");" );
			}

			// 1 - NullVoice Bind Descriptions
			for (%i = 0; %i < 14; %i++) {
				%text = %commandObj.nullChatText[%i];
				%sound = %commandObj.nullChatSound[%i];
				if ((%text !$= "") && (%sound !$= ""))
					%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(1, " @ %i @ ", \"" @ ECMfixQuotesForSave(%text) @ "\", \"" @ %sound @ "\");" );
			}

			// 2 - ECM Function Descriptions
			if (%commandObj.ECMFunction !$= "") {
				%text = %commandObj.ECMFunction;
				%sound = %commandObj.ECMFunctionParameters;
				%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(2, " @ %i @ ", \"" @ ECMfixQuotesForSave(%text) @ "\", \"" @ ECMfixQuotesForSave(%sound) @ "\");" );
			}

			// 3 - Console Command
			if (%commandObj.consoleCommand !$= "") {
				%text = %commandObj.consoleCommand;
				%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(3, " @ %i @ ", \"" @ ECMfixQuotesForSave(%text) @ "\");" );
			}

			// 4 -Canned Chat Item
			if (%commandObj.cannedChat !$= "") {
				%text = %commandObj.cannedChat;
				%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(4, 0, \"" @ %text @ "\");" );
			}

			// 5 -Voice Pack Root Item
			if (%commandObj.startVoicePack !$="") {
				%text = %commandObj.startVoicePack;
				%file.writeLine( "\t" @ %space @ "ECMenuBuild.addCmdDesc(5, 0, \"" @ %text @ "\");" );
			}

			//End this Bind
			%file.writeLine( %space @ "ECMenuBuild.endCmdBind();" );

		}

	}

}
