//This script contains code to enable selection of any voice with any sex/species


//This package over-rides existing GUI functions that handle voice selection
package ECM_VoicePopupOverridePackage {

	function GMW_VoicePopup::fillList( %this, %raceGender )
	{
		%this.clear();

		//Fill with items in my menu
		//$TracerECM::VoiceLabels[0] = "Bot";
		//$TracerECM::VoiceDirs[0] = "Bot1";

		for (%i = 0; %i < $TracerECM::VoiceCount; %i++)
			%this.add($TracerECM::VoiceLabels[%i], %i);
		
	
	}

	//------------------------------------------------------------------------------
	function GMW_VoicePopup::onSelect( %this, %id, %text )
	{
		// Update the player pref:
		%voiceNum = GMW_VoicePopup.getSelected();
		
		$pref::Player[$pref::Player::Current] = setField( $pref::Player[$pref::Player::Current], 3, $TracerECM::VoiceDirs[%voiceNum] );

		%this.voiceIndex = 0;
	}
	
	function GMW_VoicePopup::test( %this )
	{
		switch ( %this.voiceIndex )
		{
			case 0: %file = "gbl.hi";
			case 1: %file = "gbl.brag";
			case 2: %file = "gbl.woohoo";
			case 3: %file = "gbl.rock";
			case 4: %file = "gbl.obnoxious";
			case 5: %file = "gbl.shazbot";
		}
	
		//Disable Voice Test button (for duration of sound)
		GMW_VoiceTestBtn.setActive( false );
		
		//Render wav file name
		%base = $TracerECM::VoiceDirs[%this.getSelected()];
		%wav = "voice/" @ %base @ "/" @ %file @ ".wav";
	
		//Create sound handle
	  	%handle = alxCreateSource( AudioGui, %wav );
	
	   	//read slider pitch
	   	%pitchSliderVal = GMW_VoicePitchSlider.getValue()-1;
	   
	   	//convert slider pitch into server valid pitch
	   	%pitch = getValidVoicePitch(%voiceId, %pitchSliderVal);
	   
		//adjust valid pitch to wider range
		%pitch = adjustPitch(%pitch);
		
		//preview the voice
		if (%pitch != 1.0)
		  alxSourcef(%handle, "AL_PITCH", %pitch);
	
		alxPlay( %handle );
	
		%delay = alxGetWaveLen( %wav );
		schedule( %delay, 0, "restoreVoiceTestButton" );
	
		if ( %this.voiceIndex == 5 )
			%this.voiceIndex = 0;
		else
			%this.voiceIndex++;
	}
	
	function GMW_WarriorPopup::onSelect( %this, %id, %text ) {
	
		%voice = getField( $pref::Player[%id], 3 );
		
		parent::onSelect( %this, %id, %text );
		
		for (%i = 0; %i < $TracerECM::VoiceCount; %i++)
			if ($TracerECM::VoiceDirs[%i] $= %voice)
				GMW_VoicePopup.setSelected(%i);
				

				
	}

};


activatePackage(ECM_VoicePopupOverridePackage);